(defun DTR (a)					;convert to radians
  (* pi (/ a 180.0))
);defun

;;;*=================================================================

(defun C:BEAM (/)				;function defined

;;;*Initialise and Setup Dialogue Box
		
  (setq OLDECHO (getvar "CMDECHO")		;store system variables
        OLDBLIP (getvar "BLIPMODE")
	OLDSNAP (getvar "OSMODE")
  );setq
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setq	NAMES '("100x55x8" "120x64x10" "140x73x13" "160x82x16"
		"180x91x19" "200x100x22" "203x133x25" "203x133x30"
		"254x146x31" "254x146x37" "254x146x43");list of names
  );setq
  (setq dialogshow T)				;set flag
  (setq dcl_id (load_dialog "beam.dcl"))	;initialise dialog box
  (if (not 					;check dcl exists
        (new_dialog "beam" dcl_id)		;load into memory
      );not
    (setq dialogshow nil)			;if not exit
  );if
(if dialogshow					;if dialog
(progn  					;continue with programme
(start_list "selections")			;start list box
  (mapcar 'add_list NAMES)			;add names from list
  (end_list)					;end list box
  (action_tile					
    "cancel"					;if cancel selected
    "(done_dialog) (setq userclick1 nil)"	;close dialog, set flag
  );action tile
  (action_tile
    "accept"					;if OK or double click
    (strcat
      "(progn (setq SIZA (atof (get_tile \"selections\")))" ;get size of beam
      "(done_dialog) (setq userclick1 T))"	;close dialog and set flag
    );strcat
  );action tile
  (start_dialog)				;display dialog
  (unload_dialog dcl_id)			;unload dialog
  (if userclick1				;if OK or double click
    (progn					;continue with programme
      (setq SIZA (fix SIZA))			;convert index to integer
      (setq SIZA (nth SIZA NAMES))		;retrieve name from list

;;;*Retrieve Data from External Data File

;;;*======================================================
;;;*This section is covered in the External Data Tutor
;;;*======================================================

      (setq dlist nil
	    size  (strcat "*" SIZA)
	    file  (findfile "beam.dat")
	    fp    (open file "r")
	    item  (read-line fp)
  );setq
  (while item
    (if	(= item size)
      (setq data (read-line fp)
	    item nil
      );setq
      (setq item (read-line fp))
    );if
  );while

;;;*Format List

  (if data
    (progn
      (setq maxs  (strlen data)
	    count 1
	    chrct 1
      );setq
      (while (< count maxs)
	(if (/= "," (substr data count 1))
	  (setq chrct (1+ chrct))
	  (setq	numb  (atof (substr data (1+ (- count chrct)) chrct))
		dlist (append dlist (list numb))
		chrct 1
	  );setq
	);if
	(setq count (1+ count))
      );while
      (setq numb  (atof (substr data (1+ (- count chrct))))
	    dlist (append dlist (list numb))
      );setq
    );progn
  );if data
  (close fp)

;;;*This routine draws the beam.

;;;*========================================================
;;;*This section is covered in the Calculating Points Tutor
;;;*========================================================

     (mapcar 'set '(H B T1 T2 R1) dlist)
      (setq OLDSNAP (getvar "OSMODE"))
      (while
      (setq IP (getpoint "\nInsertion Point: "))
      (setvar "OSMODE" 0)
      (setq P1	(polar IP 0 (/ T1 2))
	    P2	(polar P1 (DTR 90.0) (/ (- H (+ T2 T2 R1 R1)) 2))
	    P3	(polar P2 (DTR 90.0) R1)
	    P4	(polar P3 0 R1)
	    P5	(polar P4 0 (/ (- B (+ T1 R1 R1)) 2))
	    P6	(polar P5 (DTR 90.0) T2)
	    P7	(polar P6 (DTR 180.0) B)
	    P8	(polar P7 (DTR 270.0) T2)
	    P9	(polar P8 0 (/ (- B (+ T1 R1 R1)) 2))
	    P10	(polar P9 0 R1)
	    P11	(polar P10 (DTR 270.0) R1)
	    P12	(polar P11 (DTR 270.0) (- H (+ T2 T2 R1 R1)))
	    P13	(polar P12 (DTR 270.0) R1)
	    P14	(polar P13 (DTR 180.0) R1)
	    P15	(polar P14 (DTR 180.0) (/ (- B (+ T1 R1 R1)) 2))
	    P16	(polar P15 (DTR 270.0) T2)
	    P17	(polar P16 0 B)
	    P18	(polar P17 (DTR 90.0) T2)
	    P19	(polar P18 (DTR 180.0) (/ (- B (+ T1 R1 R1)) 2))
	    P20	(polar P19 (DTR 180.0) R1)
	    P21	(polar P20 (DTR 90.0) R1)
      );setq
      (command "PLINE" P1 "W" "0.0" "0.0" P2 "ARC"
	       P4 "LINE" P5 P6 P7 P8 P9	"ARC"
	       P11 "LINE" P12 "ARC" P14 "LINE" P15 P16
	       P17 P18 P19 "ARC" P21 "LINE" P1 ""
      );command         
      (prompt "\nRotation Angle: ")
      (command "ROTATE" "LAST" "" IP pause
      );command
      (setvar "OSMODE" OLDSNAP)
     );while  
    );progn
  );if userclick1
);progn
);if dialogshow
(setvar "OSMODE" OLDSNAP)
(setvar "BLIPMODE" OLDBLIP)
(setvar "CMDECHO" OLDECHO)
  (princ)
);defun BEAM


